## lnav 0.11.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

include(cmake/prelude.cmake)

set(CMAKE_CXX_STANDARD 14)
project(
        lnav
        VERSION 0.11.1
        DESCRIPTION "An advanced log file viewer for the small-scale."
        HOMEPAGE_URL "https://lnav.org/"
        LANGUAGES CXX C
)

include(cmake/project-is-top-level.cmake)
include(cmake/variables.cmake)

find_package(SQLite3 REQUIRED)
find_package(BZip2 REQUIRED)
find_package(LibArchive REQUIRED)
find_package(ZLIB REQUIRED)
find_package(pcre REQUIRED)
find_package(pcre2 REQUIRED)
find_package(readline REQUIRED)
find_package(ncurses REQUIRED)
find_package(CURL REQUIRED)

set(lnav_LIBS
        CURL::libcurl
        SQLite::SQLite3
        BZip2::BZip2
        ncurses::libcurses
        pcre::libpcre
        pcre2::pcre2
        readline::readline
        LibArchive::LibArchive
        ZLIB::ZLIB
        )

add_subdirectory(src)
# add_subdirectory(test)

# ---- Install rules ----

if (NOT CMAKE_SKIP_INSTALL_RULES)
    include(cmake/install-rules.cmake)
endif ()

# ---- Developer mode ----

if (NOT lnav_DEVELOPER_MODE)
    return()
elseif (NOT PROJECT_IS_TOP_LEVEL)
    message(
            AUTHOR_WARNING
            "Developer mode is intended for developers of lnav"
    )
endif ()

include(cmake/dev-mode.cmake)

=== docs/requirements.txt ===
sphinx>=4.3.0
sphinx-jsonschema
sphinx-prompt
pathlib
sphinx-rtd-theme>=0.5.1

=== release/Makefile ===

VERSION=0.11.1

VERSION_TAG=v$(VERSION)

SRC_VERSION=master

outbox:
	mkdir -p $@

clean-outbox: outbox
	rm -f outbox/*

PACKAGE_URLS = \
	https://www.libarchive.org/downloads/libarchive-3.6.1.tar.gz \
	https://ftp.gnu.org/gnu/make/make-4.2.1.tar.gz \
	ftp://ftp.gnu.org/gnu/ncurses/ncurses-6.3.tar.gz \
	https://github.com/PCRE2Project/pcre2/releases/download/pcre2-10.40/pcre2-10.40.tar.gz \
	https://ftp.gnu.org/gnu/readline/readline-6.3.tar.gz \
	https://zlib.net/zlib-1.2.12.tar.gz \
	https://sourceware.org/pub/bzip2/bzip2-1.0.8.tar.gz \
	https://www.sqlite.org/2022/sqlite-autoconf-3390400.tar.gz \
	https://www.openssl.org/source/openssl-1.0.2n.tar.gz \
	https://www.libssh2.org/download/libssh2-1.9.0.tar.gz \
	https://curl.se/download/curl-7.85.0.tar.gz \
	https://tukaani.org/xz/xz-5.2.5.tar.gz

.PHONY: linux freebsd pkger download-pkgs musl

%-vm: %
	cd vagrant-static && vagrant up $<

download-pkgs:
	mkdir -p vagrant-static/pkgs && cd vagrant-static/pkgs && \
	for pkg in $(PACKAGE_URLS); do \
		if ! wget -N $${pkg}; then \
		  exit 1; \
		fi \
	done

%-build: % %-vm
	cd vagrant-static && vagrant ssh $< -c "/vagrant/build.sh ${SRC_VERSION}"

%-package: % clean-outbox %-build
	mkdir -p $<-pkg/lnav-${VERSION}
	cp ../README ../NEWS.md $<-pkg/lnav-${VERSION}
	mv vagrant-static/lnav $<-pkg/lnav-${VERSION}
	cd $<-pkg && zip -r ../outbox/lnav-${VERSION}-x86_64-linux-$<.zip lnav-${VERSION}
	rm -rf $<-pkg

linux-ospkg: pkger-vm linux-package
	rm -f vagrant-static/lnav\*.deb vagrant-static/lnav\*.rpm
	cd vagrant-static && vagrant ssh pkger -c "/vagrant/build-pkg.sh ${VERSION}"
	mv vagrant-static/lnav*.deb vagrant-static/lnav*.rpm outbox/

osx-build:
	rm -rf osx-build-dir
	mkdir -p osx-build-dir
	cd ../ && ./autogen.sh
	cd osx-build-dir && \
	  ../../configure --enable-static \
	  --with-readline=/usr/local/opt/readline \
	  --with-sqlite3=/usr/local/opt/sqlite \
	  --with-libarchive=/usr/local/opt/libarchive \
	  "CXXFLAGS=-I/usr/local/opt/ncurses/include -g1 -O2" \
	  "CFLAGS=-I/usr/local/opt/ncurses/include -g1 -O2" \
	  "LDFLAGS=-L/usr/local/opt/ncurses/lib -L/usr/local/opt/xz/lib" \
	  "LIBS=-llzma -lzstd -lbrotlidec-static -liconv -llz4" \
	  && make -j8 && make dist -j8 && make dist-bzip2

osx-package: clean-outbox osx-build
	mkdir -p osx-pkg/lnav-${VERSION}
	git pull --rebase
	cp ../README ../NEWS.md osx-pkg/lnav-${VERSION}
	cp osx-build-dir/src/lnav osx-pkg/lnav-${VERSION}
	cp osx-build-dir/lnav-${VERSION}.tar.gz outbox/
	cp osx-build-dir/lnav-${VERSION}.tar.bz2 outbox/
	cd osx-pkg && zip -r ../outbox/lnav-${VERSION}-x86_64-macos.zip lnav-${VERSION}
	rm -rf osx-pkg

release-NEWS.md: ../NEWS.md
	sed -n "/^## lnav v${VERSION}/,/^## /p" $< | sed '$$d' > $@

release-tag: release-NEWS.md
	gh release create ${VERSION_TAG} \
		-d \
		-t "lnav v${VERSION}" \
		--notes-file release-NEWS.md

release: osx-package musl-package release-NEWS.md
	gh release edit ${VERSION_TAG} \
		-t "lnav v${VERSION}" \
		--notes-file release-NEWS.md
	gh release upload ${VERSION_TAG} outbox/*

push:
	env LANG=UTF-8 package_cloud push tstack/lnav/ubuntu/lucid outbox/lnav*.deb
	env LANG=UTF-8 package_cloud push tstack/lnav/el/5 outbox/lnav-0.11.1-1.x86_64.rpm

clean:
	cd vagrant-static && vagrant destroy -f
	rm -rf vagrant-static/pkgs

=== src/CMakeLists.txt ===
include(CheckTypeSize)
include(CheckIncludeFile)
include(CheckLibraryExists)
include(CheckFunctionExists)

check_type_size(off_t SIZEOF_OFF_T)

check_include_file("pty.h" HAVE_PTY_H)
check_include_file("util.h" HAVE_UTIL_H)
check_include_file("execinfo.h" HAVE_EXECINFO_H)

set(VCS_PACKAGE_STRING "lnav ${CMAKE_PROJECT_VERSION}")
set(PACKAGE_VERSION "${CMAKE_PROJECT_VERSION}")

configure_file(config.cmake.h.in config.h)

add_subdirectory(base)
add_subdirectory(pcrepp)
add_subdirectory(remote)
add_subdirectory(tailer)
add_subdirectory(formats/logfmt)
add_subdirectory(yajl)
add_subdirectory(yajlpp)

add_executable(bin2c bin2c.hh ../tools/bin2c.c)
target_link_libraries(bin2c ZLIB::ZLIB)

add_executable(ptimec ptimec.hh ptimec.c)

set(TIME_FORMATS
        "@%@"
        "%Y-%m-%d %H:%M:%S"
        "%Y-%m-%d %H:%M:%S%z"
        "%Y-%m-%d %H:%M:%S %z"
        "%Y-%m-%d %H:%M"
        "%Y-%m-%dT%H:%M:%S.%f%z"
        "%y-%m-%dT%H:%M:%S.%f%z"
        "%Y-%m-%dT%H:%M:%SZ"
        "%Y-%m-%dT%H:%M:%S%z"
        "%Y-%m-%dT%H:%M:%S"
        "%Y-%m-%dT%H:%M:%S%z"
        "%Y/%m/%d %H:%M:%S"
        "%Y/%m/%d %H:%M:%S %z"
        "%Y/%m/%d %H:%M:%S%z"
        "%Y/%m/%d %H:%M"
        "%Y %b %d %a %H:%M:%S.%L"
        "%Y %b %d %H:%M:%S.%L"
        "%Y %b %d %H:%M:%S"
        "%a %b %d %H:%M:%S %Y"
        "%a %b %d %H:%M:%S.%f %Y"
        "%a %b %d %H:%M:%S %Z %Y"
        "%a %b %d %H:%M:%S "
        "%a %b %d %H:%M:%S.%L "
        "%a %b %d %H:%M "
        "%a %b %e %H:%M:%S %Z %Y"
        "%d/%b/%Y:%H:%M:%S +0000"
        "%d/%b/%Y:%H:%M:%S %z"
        "%d-%b-%Y %H:%M:%S %z"
        "%d-%b-%Y %H:%M:%S %Z"
        "%d %b %Y %H:%M:%S"
        "%d %b %Y %H:%M:%S.%L"
        "%d %b %Y %H:%M:%S,%L"
        "%b %d %H:%M:%S"
        "%b %d %k:%M:%S"
        "%b %d %l:%M:%S"
        "%b %e, %Y %l:%M:%S %p"
        "%m/%d/%y %H:%M:%S"
        "%m/%d/%Y %I:%M:%S:%L %p %Z"
        "%m/%d/%Y %I:%M:%S %p %Z"
        "%m/%d/%Y %l:%M:%S %p %Z"
        "%m/%e/%Y %I:%M:%S %p"
        "%m/%e/%Y %l:%M:%S %p"
        "%m/%d/%Y %H:%M:%S"
        "%d/%b/%y %H:%M:%S"
        "%m%d %H:%M:%S"
        "%Y%m%d %H:%M:%S"
        "%Y%m%d.%H%M%S"
        "%H:%M:%S"
        "%M:%S"
        "%m/%d %H:%M:%S"
        "%Y-%m-%d"
        "%Y-%m"
        "%Y/%m/%d"
        "%Y/%m"
        "%s.%f")

set(GEN_SRCS "")

add_custom_command(OUTPUT time_fmts.cc COMMAND ptimec ${TIME_FORMATS} >
        time_fmts.cc)

add_library(lnavdt STATIC config.h.in ptimec.hh ptimec_rt.cc time_fmts.cc)
target_include_directories(lnavdt PUBLIC . ${CMAKE_CURRENT_BINARY_DIR})

function(bin2c)
    cmake_parse_arguments(BIN2C_ "" "VARNAME" "" ${ARGN})

    list(TRANSFORM BIN2C_UNPARSED_ARGUMENTS "\\." "-")
    add_custom_command(
            OUTPUT "${DST_FILE}.h" "${DST_FILE}.cc"
            COMMAND bin2c "${DST_FILE}" "${CMAKE_CURRENT_SOURCE_DIR}/${FILE_TO_LINK}"
            DEPENDS bin2c "${FILE_TO_LINK}")
endfunction(bin2c)

foreach (FILE_TO_LINK animals.json ansi-palette.json diseases.json emojis.json xml-entities.json xterm-palette.json help.txt help.md init.sql words.json)
    string(REPLACE "." "-" DST_FILE "${FILE_TO_LINK}")
    add_custom_command(
            OUTPUT "${DST_FILE}.h" "${DST_FILE}.cc"
            COMMAND bin2c "${DST_FILE}" "${CMAKE_CURRENT_SOURCE_DIR}/${FILE_TO_LINK}"
            DEPENDS bin2c "${FILE_TO_LINK}")
    list(APPEND GEN_SRCS "${CMAKE_CURRENT_BINARY_DIR}/${DST_FILE}.h"
            "${CMAKE_CURRENT_BINARY_DIR}/${DST_FILE}.cc")
endforeach (FILE_TO_LINK)

set(FORMAT_FILES
        formats/access_log.json
        formats/alb_log.json
        formats/block_log.json
        formats/candlepin_log.json
        formats/choose_repo_log.json
        formats/cups_log.json
        formats/dpkg_log.json
        formats/elb_log.json
        formats/engine_log.json
        formats/error_log.json
        formats/esx_syslog_log.json
        formats/fsck_hfs_log.json
        formats/glog_log.json
        formats/haproxy_log.json
        formats/java_log.json
        formats/journald_json_log.json
        formats/katello_log.json
        formats/openam_log.json
        formats/openamdb_log.json
        formats/openstack_log.json
        formats/page_log.json
        formats/papertrail_log.json
        formats/pcap_log.json
        formats/procstate_log.json
        formats/snaplogic_log.json
        formats/sssd_log.json
        formats/strace_log.json
        formats/sudo_log.json
        formats/syslog_log.json
        formats/s3_log.json
        formats/tcf_log.json
        formats/tcsh_history.json
        formats/uwsgi_log.json
        formats/vdsm_log.json
        formats/vmk_log.json
        formats/vmw_log.json
        formats/vmw_vc_svc_log.json
        formats/vmw_py_log.json
        formats/xmlrpc_log.json)

set(FORMAT_FILE_PATHS ${FORMAT_FILES})

list(TRANSFORM FORMAT_FILE_PATHS PREPEND "${CMAKE_CURRENT_SOURCE_DIR}/")

add_custom_command(
        OUTPUT default-formats.h default-formats.cc
        COMMAND bin2c -n lnav_format_json default-formats ${FORMAT_FILE_PATHS}
        DEPENDS bin2c ${FORMAT_FILES})
list(APPEND GEN_SRCS default-formats.h default-formats.cc)

set(CONFIG_FILES
        root-config.json
        keymaps/de-keymap.json
        keymaps/default-keymap.json
        keymaps/fr-keymap.json
        keymaps/uk-keymap.json
        keymaps/us-keymap.json
        themes/default-theme.json
        themes/grayscale.json
        themes/eldar.json
        themes/monocai.json
        themes/night-owl.json
        themes/solarized-dark.json
        themes/solarized-light.json)

set(CONFIG_FILE_PATHS ${CONFIG_FILES})

list(TRANSFORM CONFIG_FILE_PATHS PREPEND "${CMAKE_CURRENT_SOURCE_DIR}/")

add_custom_command(
        OUTPUT default-config.h default-config.cc
        COMMAND bin2c -n lnav_config_json default-config ${CONFIG_FILE_PATHS}
        DEPENDS bin2c ${CONFIG_FILES})
list(APPEND GEN_SRCS default-config.h default-config.cc)

set(BUILTIN_LNAV_SCRIPTS
        scripts/dhclient-summary.lnav scripts/lnav-pop-view.lnav
        scripts/partition-by-boot.lnav scripts/rename-stdin.lnav
        scripts/search-for.lnav)

set(BUILTIN_LNAV_SCRIPT_PATHS ${BUILTIN_LNAV_SCRIPTS})

list(TRANSFORM BUILTIN_LNAV_SCRIPT_PATHS PREPEND "${CMAKE_CURRENT_SOURCE_DIR}/")

add_custom_command(
        OUTPUT builtin-scripts.h builtin-scripts.cc
        COMMAND bin2c -n lnav_scripts builtin-scripts ${BUILTIN_LNAV_SCRIPT_PATHS}
        DEPENDS bin2c ${BUILTIN_LNAV_SCRIPTS})
list(APPEND GEN_SRCS builtin-scripts.h builtin-scripts.cc)

set(BUILTIN_SH_SCRIPTS scripts/dhclient-summary.lnav scripts/lnav-pop-view.lnav
        scripts/partition-by-boot.lnav scripts/search-for.lnav)

set(BUILTIN_SH_SCRIPT_PATHS ${BUILTIN_SH_SCRIPTS})

list(TRANSFORM BUILTIN_SH_SCRIPT_PATHS PREPEND "${CMAKE_CURRENT_SOURCE_DIR}/")

add_custom_command(
        OUTPUT builtin-sh-scripts.h builtin-sh-scripts.cc
        COMMAND bin2c -n lnav_sh_scripts builtin-sh-scripts ${BUILTIN_SH_SCRIPT_PATHS}
        DEPENDS bin2c ${BUILTIN_SH_SCRIPTS})
list(APPEND GEN_SRCS builtin-sh-scripts.h builtin-sh-scripts.cc)

add_library(
        cppfmt STATIC
        fmtlib/format.cc
        fmtlib/os.cc
        fmtlib/fmt/args.h
        fmtlib/fmt/chrono.h
        fmtlib/fmt/color.h
        fmtlib/fmt/compile.h
        fmtlib/fmt/core.h
        fmtlib/fmt/format-inl.h
        fmtlib/fmt/format.h
        fmtlib/fmt/locale.h
        fmtlib/fmt/os.h
        fmtlib/fmt/ostream.h
        fmtlib/fmt/printf.h
        fmtlib/fmt/ranges.h
        fmtlib/fmt/std.h
        fmtlib/fmt/xchar.h
)
target_include_directories(cppfmt PUBLIC fmtlib)

add_library(
        cppscnlib STATIC
        third-party/scnlib/src/reader_float.cpp
        third-party/scnlib/src/reader_int.cpp
        third-party/scnlib/src/locale.cpp
        third-party/scnlib/src/file.cpp
        third-party/scnlib/src/vscan.cpp

        third-party/scnlib/include/scn/reader/reader.h
        third-party/scnlib/include/scn/reader/float.h
        third-party/scnlib/include/scn/reader/types.h
        third-party/scnlib/include/scn/reader/int.h
        third-party/scnlib/include/scn/reader/common.h
        third-party/scnlib/include/scn/reader/string.h
        third-party/scnlib/include/scn/ranges/custom_impl.h
        third-party/scnlib/include/scn/ranges/std_impl.h
        third-party/scnlib/include/scn/ranges/ranges.h
        third-party/scnlib/include/scn/ranges/util.h
        third-party/scnlib/include/scn/fwd.h
        third-party/scnlib/include/scn/util/algorithm.h
        third-party/scnlib/include/scn/util/small_vector.h
        third-party/scnlib/include/scn/util/optional.h
        third-party/scnlib/include/scn/util/expected.h
        third-party/scnlib/include/scn/util/array.h
        third-party/scnlib/include/scn/util/unique_ptr.h
        third-party/scnlib/include/scn/util/math.h
        third-party/scnlib/include/scn/util/memory.h
        third-party/scnlib/include/scn/util/span.h
        third-party/scnlib/include/scn/util/meta.h
        third-party/scnlib/include/scn/util/string_view.h
        third-party/scnlib/include/scn/unicode/unicode.h
        third-party/scnlib/include/scn/unicode/common.h
        third-party/scnlib/include/scn/unicode/utf16.h
        third-party/scnlib/include/scn/unicode/utf8.h
        third-party/scnlib/include/scn/all.h
        third-party/scnlib/include/scn/tuple_return/tuple_return.h
        third-party/scnlib/include/scn/tuple_return/util.h
        third-party/scnlib/include/scn/scan/ignore.h
        third-party/scnlib/include/scn/scan/getline.h
        third-party/scnlib/include/scn/scan/list.h
        third-party/scnlib/include/scn/scan/common.h
        third-party/scnlib/include/scn/scan/istream.h
        third-party/scnlib/include/scn/scan/vscan.h
        third-party/scnlib/include/scn/scan/scan.h
        third-party/scnlib/include/scn/tuple_return.h
        third-party/scnlib/include/scn/detail/error.h
        third-party/scnlib/include/scn/detail/fwd.h
        third-party/scnlib/include/scn/detail/range.h
        third-party/scnlib/include/scn/detail/locale.h
        third-party/scnlib/include/scn/detail/config.h
        third-party/scnlib/include/scn/detail/file.h
        third-party/scnlib/include/scn/detail/context.h
        third-party/scnlib/include/scn/detail/result.h
        third-party/scnlib/include/scn/detail/visitor.h
        third-party/scnlib/include/scn/detail/args.h
        third-party/scnlib/include/scn/detail/parse_context.h
        third-party/scnlib/include/scn/detail/vectored.h
        third-party/scnlib/include/scn/scn.h
        third-party/scnlib/include/scn/istream.h
)
target_include_directories(cppscnlib PRIVATE third-party/scnlib/src/deps/fast_float/single_include)
target_include_directories(cppscnlib PUBLIC third-party/scnlib/include)

add_library(
        base64 STATIC
        third-party/base64/lib/lib.c
        third-party/base64/lib/arch/generic/codec.c
        third-party/base64/lib/tables/tables.c
)
target_include_directories(base64 PRIVATE third-party/base64/lib)
target_include_directories(base64 PUBLIC third-party/base64/include)

add_library(
        spookyhash STATIC
        spookyhash/SpookyV2.cpp
)

add_library(lnavfileio STATIC
        grep_proc.hh
        line_buffer.hh
        pollable.hh
        shared_buffer.hh

        grep_proc.cc
        line_buffer.cc
        pollable.cc
        shared_buffer.cc
        )
target_include_directories(lnavfileio PRIVATE . ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(lnavfileio cppfmt spookyhash pcrepp base BZip2::BZip2 ZLIB::ZLIB)

add_library(
        diag STATIC
        ${GEN_SRCS}
        config.h.in
        all_logs_vtab.cc
        archive_manager.cc
        document.sections.cc
        bin2c.hh
        bookmarks.cc
        bottom_status_source.cc
        breadcrumb_curses.cc
        collation-functions.cc
        column_namer.cc
        command_executor.cc
        curl_looper.cc
        db_sub_source.cc
        dump_internals.cc
        elem_to_json.cc
        environ_vtab.cc

=== test/CMakeLists.txt ===
enable_testing()

include_directories(
        . ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src/fmtlib
        ${CMAKE_CURRENT_BINARY_DIR}/../src ${CMAKE_CURRENT_BINARY_DIR})

add_executable(test_abbrev test_abbrev.cc test_stubs.cc)
target_link_libraries(test_abbrev diag)
add_test(NAME test_abbrev COMMAND test_abbrev)

add_executable(test_ansi_scrubber test_ansi_scrubber.cc test_stubs.cc)
target_link_libraries(test_ansi_scrubber diag)
add_test(NAME test_ansi_scrubber COMMAND test_ansi_scrubber)

add_executable(test_auto_fd test_auto_fd.cc test_stubs.cc)
target_link_libraries(test_auto_fd diag)
add_test(NAME test_auto_fd COMMAND test_auto_fd)

add_executable(test_auto_mem test_auto_mem.cc test_stubs.cc)
target_link_libraries(test_auto_mem diag)
add_test(NAME test_auto_mem COMMAND test_auto_mem)

add_executable(test_column_namer test_column_namer.cc test_stubs.cc)
target_include_directories(test_column_namer PUBLIC ../src/third-party/doctest-root)
target_link_libraries(test_column_namer diag)
add_test(NAME test_column_namer COMMAND test_column_namer)

add_executable(document.sections.tests document.sections.tests.cc test_stubs.cc)
target_include_directories(document.sections.tests PUBLIC ../src/third-party/doctest-root)
target_link_libraries(document.sections.tests diag)
add_test(NAME document.sections.tests COMMAND document.sections.tests)

add_executable(test_bookmarks test_bookmarks.cc test_stubs.cc)
target_link_libraries(test_bookmarks diag)
add_test(NAME test_bookmarks COMMAND test_bookmarks)

add_executable(test_date_time_scanner test_date_time_scanner.cc)
target_link_libraries(test_date_time_scanner base lnavdt)
add_test(NAME test_date_time_scanner COMMAND test_date_time_scanner)

add_executable(test_grep_proc2 test_grep_proc2.cc)
target_link_libraries(test_grep_proc2 lnavfileio)
add_test(NAME test_grep_proc2 COMMAND test_grep_proc2)

add_executable(test_line_buffer2 test_line_buffer2.cc)
target_link_libraries(test_line_buffer2 lnavfileio)
add_test(NAME test_line_buffer2 COMMAND test_line_buffer2)

add_executable(test_log_accel test_log_accel.cc test_stubs.cc)
target_link_libraries(test_log_accel diag)
add_test(NAME test_log_accel COMMAND test_log_accel)

add_executable(lnav_doctests lnav_doctests.cc test_stubs.cc)
target_include_directories(lnav_doctests PUBLIC ../src/third-party/doctest-root)
target_link_libraries(lnav_doctests diag ${lnav_LIBS})
add_test(NAME lnav_doctests COMMAND lnav_doctests)

add_executable(test_reltime test_reltime.cc test_stubs.cc)
target_include_directories(test_reltime PUBLIC ../src/third-party/doctest-root)
target_link_libraries(test_reltime diag)
add_test(NAME test_reltime COMMAND test_reltime)

add_executable(test_top_status test_top_status.cc test_stubs.cc)
target_link_libraries(test_top_status diag logfmt)
add_test(NAME test_top_status COMMAND test_top_status)

add_executable(test_text_anonymizer test_text_anonymizer.cc test_stubs.cc)
target_include_directories(test_text_anonymizer PUBLIC ../src/third-party/doctest-root)
target_link_libraries(test_text_anonymizer diag)
add_test(NAME test_text_anonymizer COMMAND test_text_anonymizer)

add_executable(drive_view_colors drive_view_colors.cc test_stubs.cc)
target_link_libraries(drive_view_colors diag)

add_executable(drive_vt52_curses drive_vt52_curses.cc test_stubs.cc)
target_link_libraries(drive_vt52_curses diag)

add_executable(drive_logfile drive_logfile.cc test_stubs.cc)
target_link_libraries(drive_logfile diag)

add_executable(drive_sql_anno drive_sql_anno.cc test_stubs.cc)
target_link_libraries(drive_sql_anno diag)

add_executable(drive_data_scanner drive_data_scanner.cc test_stubs.cc)
target_link_libraries(drive_data_scanner diag logfmt)

add_executable(scripty scripty.cc test_stubs.cc)
target_link_libraries(scripty diag)

=== src/base/CMakeLists.txt ===
add_library(
        base STATIC
        ../config.h.in
        ansi_scrubber.cc
        attr_line.cc
        attr_line.builder.cc
        auto_pid.cc
        date_time_scanner.cc
        fs_util.cc
        humanize.cc
        humanize.network.cc
        humanize.time.cc
        intern_string.cc
        is_utf8.cc
        isc.cc
        lnav.console.cc
        lnav.gzip.cc
        lnav_log.cc
        network.tcp.cc
        paths.cc
        snippet_highlighters.cc
        string_attr_type.cc
        string_util.cc
        strnatcmp.c
        time_util.cc

        ansi_scrubber.hh
        attr_line.hh
        attr_line.builder.hh
        auto_fd.hh
        auto_mem.hh
        auto_pid.hh
        bus.hh
        date_time_scanner.hh
        enum_util.hh
        fs_util.hh
        func_util.hh
        future_util.hh
        humanize.hh
        humanize.network.hh
        humanize.time.hh
        injector.hh
        injector.bind.hh
        intern_string.hh
        is_utf8.hh
        isc.hh
        itertools.hh
        lnav.console.hh
        lnav.console.into.hh
        log_level_enum.hh
        lrucache.hpp
        math_util.hh
        network.tcp.hh
        paths.hh
        result.h
        snippet_highlighters.hh
        string_attr_type.hh
        strnatcmp.h
        time_util.hh

        ../third-party/xxHash/xxhash.h
        ../third-party/xxHash/xxhash.c
)

target_include_directories(base PUBLIC . .. ../third-party
        ${CMAKE_CURRENT_BINARY_DIR}/..)
target_link_libraries(base cppfmt cppscnlib pcrepp ncurses::libcurses pthread)

add_executable(
        test_base
        attr_line.tests.cc
        fs_util.tests.cc
        humanize.file_size.tests.cc
        humanize.network.tests.cc
        humanize.time.tests.cc
        intern_string.tests.cc
        lnav.gzip.tests.cc
        string_util.tests.cc
        network.tcp.tests.cc
        test_base.cc)
target_include_directories(test_base PUBLIC ../third-party/doctest-root)
target_link_libraries(test_base base pcrepp ZLIB::ZLIB)
add_test(NAME test_base COMMAND test_base)

=== debian/changelog ===
lnav (0.11.1-2~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Philipp Huebner <debalance@debian.org>  Fri, 31 Mar 2023 16:25:21 +0200

lnav (0.11.1-2) unstable; urgency=medium

  * Add Build-Depends on tzdata.
    Thanks to Santiago Vila (Closes: #1029426)
  * Update copyright years for debian/* packaging files
  * Declare compliance with Debian policy 4.6.2

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 22 Jan 2023 20:41:56 +0100

lnav (0.11.1-1) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Wed, 16 Nov 2022 09:09:42 +0100

lnav (0.11.1-1~exp2) experimental; urgency=medium

  * Produce no debug information for mipsel builds (Closes: #1021665)

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 15 Nov 2022 16:39:16 +0100

lnav (0.11.1-1~exp1) experimental; urgency=medium

  * New upstream version 0.11.1

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 20 Oct 2022 23:21:15 +0200

lnav (0.11.1~rc1-1~exp1) experimental; urgency=medium

  * New upstream version 0.11.1~rc1
  * Update copyright stanzas for upstream included files
  * debian/watch: Add uversionmangle to be able to import rc versions as well
  * Drop "remove unnecessary include that is triggering a compile error on
    some archs"
  * Drop "Disable the 'truncate_to' test (causes FTBFS on s390x)"
  * d/control: Switch Build-Depends to libpcre2-dev (Closes: #1000078)
  * d/rules: Install NEWS.md as upstream changelog (renamed from NEWS
    upstream)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 08 Oct 2022 19:11:40 +0200

lnav (0.11.0-1~exp2) experimental; urgency=medium

  * remove unnecessary include that is triggering a compile error on some
    archs

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 30 Sep 2022 15:01:26 +0200

lnav (0.11.0-1~exp1) experimental; urgency=medium

  * New upstream version 0.11.0
  * Refresh "Prefer /var/log/syslog over /var/log/messages"
  * debian/watch: Switch to watch tagged versions on github releases page
  * Refresh "Disable test_mvwattrline test"
  * Refresh "Disable failing test_vt52_curses test"
  * Refresh "Disable broken test_logfile.sh test"
  * Refresh "Disable test_sql completely as contains time dependent tests"
  * Refresh "Disable broken test_listview.sh test"
  * Drop patches applied upstream
  * Refresh "Disable the 'truncate_to' test (causes FTBFS on s390x)"
  * Update copyright years for upstream files

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 30 Sep 2022 09:17:31 +0200

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Produce no debug information for mipsel builds
# to avoid FTBFS due to running out of memory,
# cf. #1021665
ifneq (,$(filter $(DEB_HOST_ARCH), mipsel))
	export DEB_CXXFLAGS_MAINT_APPEND = -g0
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --disable-static

override_dh_installchangelogs:
	dh_installchangelogs NEWS.md

override_dh_dwz:
	# dwz in bullseye fails on lnav binary

## lnav 0.11.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 set(CMAKE_CXX_STANDARD 14)
 project(
         lnav
-        VERSION 0.11.1
+        VERSION 0.11.2
         DESCRIPTION "An advanced log file viewer for the small-scale."
         HOMEPAGE_URL "https://lnav.org/"
         LANGUAGES CXX C

=== docs/requirements.txt ===
sphinx>=4.3.0
sphinx-copybutton
sphinx-jsonschema
sphinx-prompt
pathlib
sphinx-rtd-theme>=0.5.1

=== release/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 
-VERSION=0.11.1
+VERSION=0.11.2
 
 VERSION_TAG=v$(VERSION)
 
@@ -12,18 +12,18 @@
 	rm -f outbox/*
 
 PACKAGE_URLS = \
-	https://www.libarchive.org/downloads/libarchive-3.6.1.tar.gz \
+	https://www.libarchive.org/downloads/libarchive-3.6.2.tar.gz \
 	https://ftp.gnu.org/gnu/make/make-4.2.1.tar.gz \
-	ftp://ftp.gnu.org/gnu/ncurses/ncurses-6.3.tar.gz \
-	https://github.com/PCRE2Project/pcre2/releases/download/pcre2-10.40/pcre2-10.40.tar.gz \
+	ftp://ftp.gnu.org/gnu/ncurses/ncurses-6.4.tar.gz \
+	https://github.com/PCRE2Project/pcre2/releases/download/pcre2-10.42/pcre2-10.42.tar.gz \
 	https://ftp.gnu.org/gnu/readline/readline-6.3.tar.gz \
-	https://zlib.net/zlib-1.2.12.tar.gz \
+	https://zlib.net/zlib-1.2.13.tar.gz \
 	https://sourceware.org/pub/bzip2/bzip2-1.0.8.tar.gz \
-	https://www.sqlite.org/2022/sqlite-autoconf-3390400.tar.gz \
+	https://www.sqlite.org/2023/sqlite-autoconf-3420000.tar.gz \
 	https://www.openssl.org/source/openssl-1.0.2n.tar.gz \
-	https://www.libssh2.org/download/libssh2-1.9.0.tar.gz \
-	https://curl.se/download/curl-7.85.0.tar.gz \
-	https://tukaani.org/xz/xz-5.2.5.tar.gz
+	https://www.libssh2.org/download/libssh2-1.11.0.tar.gz \
+	https://curl.se/download/curl-8.1.2.tar.gz \
+	https://tukaani.org/xz/xz-5.4.3.tar.gz
 
 .PHONY: linux freebsd pkger download-pkgs musl
 
@@ -95,8 +95,11 @@
 
 push:
 	env LANG=UTF-8 package_cloud push tstack/lnav/ubuntu/lucid outbox/lnav*.deb
-	env LANG=UTF-8 package_cloud push tstack/lnav/el/5 outbox/lnav-0.11.1-1.x86_64.rpm
+	env LANG=UTF-8 package_cloud push tstack/lnav/el/5 outbox/lnav-0.11.2-1.x86_64.rpm
 
 clean:
 	cd vagrant-static && vagrant destroy -f
 	rm -rf vagrant-static/pkgs
+
+lnav.spec: lnav.spec.in makespec.sh
+	./makespec.sh < lnav.spec.in > $@

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -76,6 +76,7 @@
         "%Y%m%d %H:%M:%S"
         "%Y%m%d.%H%M%S"
         "%H:%M:%S"
+        "%H:%M:%S.%f"
         "%M:%S"
         "%m/%d %H:%M:%S"
         "%Y-%m-%d"

=== src/pcrepp/CMakeLists.txt ===
add_library(pcrepp STATIC
        ../config.h.in
        pcre2pp.hh
        pcre2pp.cc)

target_include_directories(pcrepp PUBLIC . .. ../third-party/scnlib/include
        ${CMAKE_CURRENT_BINARY_DIR}/..)
target_link_libraries(pcrepp cppfmt pcre::libpcre pcre2::pcre2)

add_executable(test_pcre2pp test_pcre2pp.cc)
target_include_directories(
        test_pcre2pp
        PUBLIC
        ../third-party/doctest-root)
target_link_libraries(test_pcre2pp pcrepp)
add_test(NAME test_pcre2pp COMMAND test_pcre2pp)

=== src/remote/CMakeLists.txt ===
add_library(remote STATIC ../config.h.in remote.ssh.cc remote.ssh.hh)

target_include_directories(remote PUBLIC . .. ../fmtlib
                                         ${CMAKE_CURRENT_BINARY_DIR}/..)
target_link_libraries(remote cppfmt pcre::libpcre)

=== src/yajlpp/CMakeLists.txt ===
add_library(
        yajlpp STATIC
        ../config.h.in
        json_op.hh
        json_ptr.hh
        yajlpp.hh
        yajlpp_def.hh

        json_op.cc
        json_ptr.cc
        yajlpp.cc
)

target_include_directories(yajlpp PUBLIC . .. ../fmtlib
        ${CMAKE_CURRENT_BINARY_DIR}/..)
target_link_libraries(yajlpp pcrepp yajl ncurses::libcurses)

add_executable(test_yajlpp test_yajlpp.cc)
target_link_libraries(test_yajlpp yajlpp base ${lnav_LIBS})
add_test(NAME test_yajlpp COMMAND test_yajlpp)

add_executable(test_json_ptr test_json_ptr.cc)
target_link_libraries(test_json_ptr yajlpp base ${lnav_LIBS})
add_test(NAME test_json_ptr COMMAND test_json_ptr)

add_executable(drive_json_op drive_json_op.cc)
target_link_libraries(drive_json_op base yajlpp ${lnav_LIBS})

=== src/formats/logfmt/CMakeLists.txt ===

add_library(
        logfmt
        STATIC
        logfmt.parser.hh
        logfmt.parser.cc
)

target_include_directories(
        logfmt
        PUBLIC
        .
        ${CMAKE_BINARY_DIR}/src
        ${CMAKE_SOURCE_DIR}/src
)
target_link_libraries(
        logfmt
        PRIVATE
        cppfmt
        cppscnlib
)

add_executable(
        logfmt.parser.test
        logfmt.parser.test.cc
)
target_include_directories(
        logfmt.parser.test
        PUBLIC
        .
        ${CMAKE_BINARY_DIR}/src
        ${CMAKE_SOURCE_DIR}/src
        ../../third-party/doctest-root)
target_link_libraries(
        logfmt.parser.test
        logfmt
        base
)

add_test(NAME logfmt.parser.test COMMAND logfmt.parser.test)

=== debian/changelog ===
lnav (0.11.2-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Philipp Huebner <debalance@debian.org>  Thu, 09 Nov 2023 09:49:06 +0100

lnav (0.11.2-1) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 05 Aug 2023 07:45:53 +0200

lnav (0.11.2-1~exp1) experimental; urgency=medium

  * New upstream version 0.11.2
    - Fixes FTBFS with gcc-13 (Closes: #1037761)
  * Drop "test_sql_str_func.sh: Correct expected output on bad IPv6 address"
  * debian/copyright: Add new stanza for freshly included file upstream

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 04 Aug 2023 08:52:25 +0200

lnav (0.11.1-3) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 31 Mar 2023 20:40:20 +0200

lnav (0.11.1-3~exp1) experimental; urgency=medium

  * test_sql_str_func.sh: Correct expected output on bad IPv6 address
    (Closes: #1032539)

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 31 Mar 2023 17:52:44 +0200

=== debian/control ===
Source: lnav
Section: admin
Priority: optional
Maintainer: Salvatore Bonaccorso <carnil@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 libarchive-dev,
 libbz2-dev,
 libcurl4-gnutls-dev,
 libncurses5-dev,
 libncursesw5-dev,
 libpcre2-dev,
 libreadline-dev,
 libsqlite3-dev,
 openssh-client,
 re2c,
 tzdata,
 zlib1g-dev,
 xz-utils
Standards-Version: 4.6.2
Homepage: https://lnav.org
Vcs-Browser: https://salsa.debian.org/carnil/lnav
Vcs-Git: https://salsa.debian.org/carnil/lnav.git
Rules-Requires-Root: no

Package: lnav
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: ncurses-based log file viewer
 The log file navigator, lnav, is an enhanced log file viewer that
 takes advantage of any semantic information that can be gleaned from
 the files being viewed, such as timestamps and log levels.  Using this
 extra semantic information, lnav can do things like interleaving
 messages from different files, generate histograms of messages over
 time, and providing hotkeys for navigating through the file.  It is
 hoped that these features will allow the user to quickly and
 efficiently zero in on problems.

## lnav 0.12.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,8 +5,8 @@
 set(CMAKE_CXX_STANDARD 14)
 project(
         lnav
-        VERSION 0.11.2
-        DESCRIPTION "An advanced log file viewer for the small-scale."
+        VERSION 0.12.2
+        DESCRIPTION "An advanced log file viewer for the terminal."
         HOMEPAGE_URL "https://lnav.org/"
         LANGUAGES CXX C
 )
@@ -34,7 +34,7 @@
         readline::readline
         LibArchive::LibArchive
         ZLIB::ZLIB
-        )
+)
 
 add_subdirectory(src)
 # add_subdirectory(test)

=== release/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 
-VERSION=0.11.2
+VERSION=0.12.2
 
 VERSION_TAG=v$(VERSION)
 
@@ -95,7 +95,7 @@
 
 push:
 	env LANG=UTF-8 package_cloud push tstack/lnav/ubuntu/lucid outbox/lnav*.deb
-	env LANG=UTF-8 package_cloud push tstack/lnav/el/5 outbox/lnav-0.11.2-1.x86_64.rpm
+	env LANG=UTF-8 package_cloud push tstack/lnav/el/5 outbox/lnav-0.12.1-1.x86_64.rpm
 
 clean:
 	cd vagrant-static && vagrant destroy -f

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -29,19 +29,35 @@
 
 set(TIME_FORMATS
         "@%@"
-        "%Y-%m-%d %H:%M:%S"
+        "%Y-%m-%d %H:%M:%S.%f%z"
+        "%Y-%m-%d %H:%M:%S,%f%z"
+        "%Y-%m-%d %H:%M:%S.%f %Z"
+        "%Y-%m-%d %H:%M:%S,%f %Z"
+        "%Y-%m-%d %H:%M:%S,%L%z"
+        "%Y-%m-%d %H:%M:%S,%L %z"
+        "%Y-%m-%d %H:%M:%S.%L%z"
+        "%Y-%m-%d %H:%M:%S.%L %z"
+        "%Y-%m-%d %H:%M:%S.%L %Z"
+        "%Y-%m-%d %H:%M:%S,%L"
+        "%Y-%m-%d %H:%M:%S.%L"
         "%Y-%m-%d %H:%M:%S%z"
         "%Y-%m-%d %H:%M:%S %z"
+        "%Y-%m-%d %H:%M:%S:%L"
+        "%Y-%m-%d %H:%M:%S"
         "%Y-%m-%d %H:%M"
         "%Y-%m-%dT%H:%M:%S.%f%z"
         "%y-%m-%dT%H:%M:%S.%f%z"
-        "%Y-%m-%dT%H:%M:%SZ"
+        "%Y-%m-%dT%H:%M:%S.%L%z"
+        "%y-%m-%dT%H:%M:%S.%L%z"
         "%Y-%m-%dT%H:%M:%S%z"
         "%Y-%m-%dT%H:%M:%S"
         "%Y-%m-%dT%H:%M:%S%z"
-        "%Y/%m/%d %H:%M:%S"
+        "%Y-%m-%dT%H:%M"
         "%Y/%m/%d %H:%M:%S %z"
         "%Y/%m/%d %H:%M:%S%z"
+        "%Y/%m/%d %H:%M:%S.%f"
+        "%Y/%m/%d %H:%M:%S.%L"
+        "%Y/%m/%d %H:%M:%S"
         "%Y/%m/%d %H:%M"
         "%Y %b %d %a %H:%M:%S.%L"
         "%Y %b %d %H:%M:%S.%L"
@@ -49,28 +65,38 @@
         "%a %b %d %H:%M:%S %Y"
         "%a %b %d %H:%M:%S.%f %Y"
         "%a %b %d %H:%M:%S %Z %Y"
+        "%a %b %d %I:%M:%S %p %Z %Y"
         "%a %b %d %H:%M:%S "
         "%a %b %d %H:%M:%S.%L "
         "%a %b %d %H:%M "
         "%a %b %e %H:%M:%S %Z %Y"
-        "%d/%b/%Y:%H:%M:%S +0000"
         "%d/%b/%Y:%H:%M:%S %z"
         "%d-%b-%Y %H:%M:%S %z"
         "%d-%b-%Y %H:%M:%S %Z"
         "%d %b %Y %H:%M:%S"
+        "%d %b %Y %H:%M:%S.%L%z"
+        "%d %b %Y %H:%M:%S,%L%z"
         "%d %b %Y %H:%M:%S.%L"
         "%d %b %Y %H:%M:%S,%L"
+        "%d %b %Y %H:%M"
         "%b %d %H:%M:%S"
         "%b %d %k:%M:%S"
         "%b %d %l:%M:%S"
+        "%b %d %l:%M"
         "%b %e, %Y %l:%M:%S %p"
-        "%m/%d/%y %H:%M:%S"
+        "%b %d, %Y %l:%M:%S %p"
         "%m/%d/%Y %I:%M:%S:%L %p %Z"
         "%m/%d/%Y %I:%M:%S %p %Z"
         "%m/%d/%Y %l:%M:%S %p %Z"
+        "%m/%d/%Y %I:%M:%S %p%z"
+        "%m/%d/%Y %l:%M:%S %p%z"
+        "%m/%e/%Y %l:%M:%S %p%z"
+        "%m/%e/%Y %l:%M:%S %p %z"
         "%m/%e/%Y %I:%M:%S %p"
-        "%m/%e/%Y %l:%M:%S %p"
+        "%m/%e/%Y %l:%M:%S%p"
+        "%m/%d/%y %H:%M:%S"
         "%m/%d/%Y %H:%M:%S"
+        "%d/%b/%Y %H:%M:%S"
         "%d/%b/%y %H:%M:%S"
         "%m%d %H:%M:%S"
         "%Y%m%d %H:%M:%S"
@@ -83,7 +109,8 @@
         "%Y-%m"
         "%Y/%m/%d"
         "%Y/%m"
-        "%s.%f")
+        "%s.%f"
+)
 
 set(GEN_SRCS "")
 
@@ -91,7 +118,7 @@
         time_fmts.cc)
 
 add_library(lnavdt STATIC config.h.in ptimec.hh ptimec_rt.cc time_fmts.cc)
-target_include_directories(lnavdt PUBLIC . ${CMAKE_CURRENT_BINARY_DIR})
+target_include_directories(lnavdt PUBLIC . ${CMAKE_CURRENT_BINARY_DIR} third-party/date/include)
 
 function(bin2c)
     cmake_parse_arguments(BIN2C_ "" "VARNAME" "" ${ARGN})
@@ -103,7 +130,7 @@
             DEPENDS bin2c "${FILE_TO_LINK}")
 endfunction(bin2c)
 
-foreach (FILE_TO_LINK animals.json ansi-palette.json diseases.json emojis.json xml-entities.json xterm-palette.json help.txt help.md init.sql words.json)
+foreach (FILE_TO_LINK animals.json ansi-palette.json css-color-names.json diseases.json emojis.json xml-entities.json xterm-palette.json help.txt help.md init.sql words.json)
     string(REPLACE "." "-" DST_FILE "${FILE_TO_LINK}")
     add_custom_command(
             OUTPUT "${DST_FILE}.h" "${DST_FILE}.cc"
@@ -164,6 +191,20 @@
         DEPENDS bin2c ${FORMAT_FILES})
 list(APPEND GEN_SRCS default-formats.h default-formats.cc)
 
+set(PRQL_FILES
+        prql/stats.prql
+        prql/utils.prql)
+
+set(PRQL_FILE_PATHS ${PRQL_FILES})
+
+list(TRANSFORM PRQL_FILE_PATHS PREPEND "${CMAKE_CURRENT_SOURCE_DIR}/")
+
+add_custom_command(
+        OUTPUT prql-modules.h prql-modules.cc
+        COMMAND bin2c -n lnav_prql_modules prql-modules ${PRQL_FILE_PATHS}
+        DEPENDS bin2c ${PRQL_FILES})
+list(APPEND GEN_SRCS prql-modules.h prql-modules.cc)
+
 set(CONFIG_FILES
         root-config.json
         keymaps/de-keymap.json
@@ -190,9 +231,15 @@
 list(APPEND GEN_SRCS default-config.h default-config.cc)
 
 set(BUILTIN_LNAV_SCRIPTS
-        scripts/dhclient-summary.lnav scripts/lnav-pop-view.lnav
-        scripts/partition-by-boot.lnav scripts/rename-stdin.lnav
-        scripts/search-for.lnav)
+        scripts/dhclient-summary.lnav
+        scripts/docker-url-handler.lnav
+        scripts/journald-url-handler.lnav
+        scripts/lnav-pop-view.lnav
+        scripts/partition-by-boot.lnav
+        scripts/piper-url-handler.lnav
+        scripts/rename-stdin.lnav
+        scripts/search-for.lnav
+)
 
 set(BUILTIN_LNAV_SCRIPT_PATHS ${BUILTIN_LNAV_SCRIPTS})
 
@@ -204,8 +251,7 @@
         DEPENDS bin2c ${BUILTIN_LNAV_SCRIPTS})
 list(APPEND GEN_SRCS builtin-scripts.h builtin-scripts.cc)
 
-set(BUILTIN_SH_SCRIPTS scripts/dhclient-summary.lnav scripts/lnav-pop-view.lnav
-        scripts/partition-by-boot.lnav scripts/search-for.lnav)
+set(BUILTIN_SH_SCRIPTS scripts/com.vmware.btresolver.py scripts/dump-pid.sh scripts/pcap_log-converter.sh)
 
 set(BUILTIN_SH_SCRIPT_PATHS ${BUILTIN_SH_SCRIPTS})
 
@@ -237,6 +283,13 @@
         fmtlib/fmt/xchar.h
 )
 target_include_directories(cppfmt PUBLIC fmtlib)
+
+add_library(
+        datepp STATIC
+        third-party/date/src/tz.cpp
+)
+target_include_directories(datepp PUBLIC third-party/date/include)
+target_link_libraries(datepp ${lnav_LIBS})
 
 add_library(
         cppscnlib STATIC
@@ -293,58 +346,3 @@
         third-party/scnlib/include/scn/detail/result.h
         third-party/scnlib/include/scn/detail/visitor.h
         third-party/scnlib/include/scn/detail/args.h
-        third-party/scnlib/include/scn/detail/parse_context.h
-        third-party/scnlib/include/scn/detail/vectored.h
-        third-party/scnlib/include/scn/scn.h
-        third-party/scnlib/include/scn/istream.h
-)
-target_include_directories(cppscnlib PRIVATE third-party/scnlib/src/deps/fast_float/single_include)
-target_include_directories(cppscnlib PUBLIC third-party/scnlib/include)
-
-add_library(
-        base64 STATIC
-        third-party/base64/lib/lib.c
-        third-party/base64/lib/arch/generic/codec.c
-        third-party/base64/lib/tables/tables.c
-)
-target_include_directories(base64 PRIVATE third-party/base64/lib)
-target_include_directories(base64 PUBLIC third-party/base64/include)
-
-add_library(
-        spookyhash STATIC
-        spookyhash/SpookyV2.cpp
-)
-
-add_library(lnavfileio STATIC
-        grep_proc.hh
-        line_buffer.hh
-        pollable.hh
-        shared_buffer.hh
-
-        grep_proc.cc
-        line_buffer.cc
-        pollable.cc
-        shared_buffer.cc
-        )
-target_include_directories(lnavfileio PRIVATE . ${CMAKE_CURRENT_BINARY_DIR})
-target_link_libraries(lnavfileio cppfmt spookyhash pcrepp base BZip2::BZip2 ZLIB::ZLIB)
-
-add_library(
-        diag STATIC
-        ${GEN_SRCS}
-        config.h.in
-        all_logs_vtab.cc
-        archive_manager.cc
-        document.sections.cc
-        bin2c.hh
-        bookmarks.cc
-        bottom_status_source.cc
-        breadcrumb_curses.cc
-        collation-functions.cc
-        column_namer.cc
-        command_executor.cc
-        curl_looper.cc
-        db_sub_source.cc
-        dump_internals.cc
-        elem_to_json.cc
-        environ_vtab.cc

=== src/base/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,9 @@
         ansi_scrubber.cc
         attr_line.cc
         attr_line.builder.cc
+        auto_fd.cc
         auto_pid.cc
+        color_spaces.cc
         date_time_scanner.cc
         fs_util.cc
         humanize.cc
@@ -18,6 +20,7 @@
         lnav_log.cc
         network.tcp.cc
         paths.cc
+        piper.file.cc
         snippet_highlighters.cc
         string_attr_type.cc
         string_util.cc
@@ -25,14 +28,18 @@
         time_util.cc
 
         ansi_scrubber.hh
+        ansi_vars.hh
         attr_line.hh
         attr_line.builder.hh
         auto_fd.hh
         auto_mem.hh
         auto_pid.hh
         bus.hh
+        color_spaces.hh
+        date_time_scanner.cfg.hh
         date_time_scanner.hh
         enum_util.hh
+        from_trait.hh
         fs_util.hh
         func_util.hh
         future_util.hh
@@ -45,26 +52,32 @@
         is_utf8.hh
         isc.hh
         itertools.hh
+        keycodes.hh
+        line_range.hh
         lnav.console.hh
         lnav.console.into.hh
         log_level_enum.hh
         lrucache.hpp
+        map_util.hh
         math_util.hh
         network.tcp.hh
         paths.hh
+        piper.file.hh
         result.h
         snippet_highlighters.hh
         string_attr_type.hh
         strnatcmp.h
         time_util.hh
+        types.hh
 
         ../third-party/xxHash/xxhash.h
         ../third-party/xxHash/xxhash.c
 )
 
 target_include_directories(base PUBLIC . .. ../third-party
+        ../third-party/date/include
         ${CMAKE_CURRENT_BINARY_DIR}/..)
-target_link_libraries(base cppfmt cppscnlib pcrepp ncurses::libcurses pthread)
+target_link_libraries(base cppfmt cppscnlib pcrepp ncurses::libcurses pthread lnavdt datepp)
 
 add_executable(
         test_base

=== src/pcrepp/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,7 @@
 add_library(pcrepp STATIC
         ../config.h.in
         pcre2pp.hh
+        pcre2pp_fwd.hh
         pcre2pp.cc)
 
 target_include_directories(pcrepp PUBLIC . .. ../third-party/scnlib/include

=== src/yajlpp/CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
 
 target_include_directories(yajlpp PUBLIC . .. ../fmtlib
         ${CMAKE_CURRENT_BINARY_DIR}/..)
-target_link_libraries(yajlpp pcrepp yajl ncurses::libcurses)
+target_link_libraries(yajlpp pcrepp yajl ncurses::libcurses datepp)
 
 add_executable(test_yajlpp test_yajlpp.cc)
 target_link_libraries(test_yajlpp yajlpp base ${lnav_LIBS})

=== debian/changelog ===
lnav (0.12.2-1) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 27 Jul 2024 08:28:54 +0200

lnav (0.12.2-1~exp2) experimental; urgency=medium

  * try to address some test issues

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 10 May 2024 22:20:40 +0200

lnav (0.12.2-1~exp1) experimental; urgency=medium

  * New upstream version 0.12.2
  * Refresh "Disable test_mvwattrline test"
  * Refresh "Disable failing test_vt52_curses test"
  * Refresh "Disable broken test_listview.sh test"
  * Add Build-Depends on libgpm-dev
  * Replace Build-Depends on libncurses{,w}5-dev with libncurses-dev
  * Disable test_config.sh test
  * Disable test_sql_json_func.sh test
  * Disable test_cli.sh test
  * Disable test_sql_str_func.sh test
  * Disable test_text_file.sh test
  * Update copyright years for upstream files
  * Declare compliance with Debian policy 4.7.0
  * Update copyright years for debian/* packaging files
  * debian/source: Add linian override for embedded-library check

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 06 May 2024 06:23:49 +0200
